/* TrevaApplet - Treva Image Viewer Applet
 * Copyright(C) 2002  Yuichi Kobayashi <kobayasy@kobayasy.com>
 *
 * This program comes with NO WARRANTY, to the extent permitted by law.
 * You may redistribute it under the terms of the GNU General Public License;
 * see the file named LICENSE.txt for details.
 */

package com.kobayasy.tini;
import java.applet.*;
import java.awt.*;

/**
 * Treva Image Viewer Applet
 *
 * @version 0.25 (20021107)
 * @author  Yuichi Kobayashi &lt;kobayasy@kobayasy.com&gt;
 */
public class TrevaApplet extends Applet implements Runnable {
  public static final String APPLETNAME = "TrevaApplet";
  public static final String VERSION = "0.25";
  public static final String APPLETINFO = APPLETNAME + " version " + VERSION +
    " - Treva Image Viewer Applet\r\n" +
    "Copyright(C) 2002  Yuichi Kobayashi <kobayasy@kobayasy.com>\r\n" +
    "This program comes with NO WARRANTY, to the extent permitted by law.\r\n" +
    "You may redistribute it under the terms of the GNU General Public License;\r\n";
  private static final String IMAGEURL = "imageURL";
  private static final String INTERVAL = "interval";
  private static final String[][] PARAMETERINFO = {
    {IMAGEURL, "URL",     "image file"},
    {INTERVAL, "seconds", "interval time"}
  };
  private String imageurl = APPLETNAME + ".png";
  private long interval = 0;
  private Image image;
  private Thread thread = null;
  public String getAppletInfo() {
    return APPLETINFO;
  }
  public String[][] getParameterInfo() {
    return PARAMETERINFO;
  }
  public void init() {
    String parameter;
    if((parameter = getParameter(IMAGEURL)) != null)
      imageurl = parameter;
    if((parameter = getParameter(INTERVAL)) != null)
      interval = Long.parseLong(parameter);
    image = getImage(getDocumentBase(), imageurl);
  }
  public void start() {
    if((interval > 0) &&
       (thread == null) ) {
      thread = new Thread(this);
      thread.start();
    }
  }
  public void stop() {
    if(thread != null) {
      thread.interrupt();
      thread = null;
    }
  }
  public void update(Graphics g) {
    paint(g);
  }
  public void paint(Graphics g) {
    g.drawImage(image, 0, 0, getWidth(), getHeight(), this);
  }
  public void run() {
    try {
      while(true) {
        thread.sleep(interval * 1000);
        image.flush();
        repaint();
      }
    } catch(InterruptedException e) {
    }
  }
}
